//+------------------------------------------------------------------+ 
//|                                               T3 Bands clean.mq4 | 
//+------------------------------------------------------------------+ 
#property indicator_separate_window 
#property indicator_buffers 5 
#property indicator_color1 Green 
#property indicator_color2 Red 
#property indicator_color3 Blue 
#property indicator_color4 Yellow 
#property indicator_color5 Silver 

//
//
//
//
//

extern string _           = "Parameters";
extern bool   t3Original  = false;
extern double b           = 0.618; 
extern int    MA_Period_1 = 5; 
extern int    MA_Period_2 = 15; 
extern int    MA_Period_3 = 20; 
extern int    MA_Period_4 = 35; 
extern int    MA_Period_5 = 80; 
//
//
//
//

double t3Array[];
double ae1[];
double ae2[];
double ae3[];
double ae4[];
double ae5[];
double ae6[];
double MapBuffer1[]; 
double MapBuffer2[]; 
double MapBuffer3[]; 
double MapBuffer4[]; 
double MapBuffer5[]; 

//
//
//
//
//

string IndicatorFileName;

//+------------------------------------------------------------------+ 
//|                                                                  | 
//+------------------------------------------------------------------+ 

int init() 
{ 
   if (_=="Calculate")
   {
      IndicatorBuffers(7);
      SetIndexBuffer(0,t3Array);
      SetIndexBuffer(1,ae1);
      SetIndexBuffer(2,ae2);
      SetIndexBuffer(3,ae3);
      SetIndexBuffer(4,ae4);
      SetIndexBuffer(5,ae5);
      SetIndexBuffer(6,ae6);
   }
   
   //
   //
   //
   //
   //
   
   else
   {
      IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS)); 
      SetIndexBuffer(0, MapBuffer1); 
      SetIndexBuffer(1, MapBuffer2); 
      SetIndexBuffer(2, MapBuffer3); 
      SetIndexBuffer(3, MapBuffer4); 
      SetIndexBuffer(4, MapBuffer5); 
      SetIndexLabel(0,"T3 "+MA_Period_1);
      SetIndexLabel(1,"T3 "+MA_Period_2);
      SetIndexLabel(2,"T3 "+MA_Period_3);
      SetIndexLabel(3,"T3 "+MA_Period_4);
      SetIndexLabel(4,"T3 "+MA_Period_5);
      IndicatorShortName("T3 Bands"); 
      IndicatorFileName=WindowExpertName();
   }      
   return(0); 
} 

//+------------------------------------------------------------------+ 
//|                                                                  | 
//+------------------------------------------------------------------+ 
//
//
//
//
//

int start()
{
   int limit, i;
   int counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = Bars - counted_bars;

   //
   //
   //
   //
   //
   
   if (_=="Calculate") CalculateT3(limit,MA_Period_1);
   else
      for(i = limit; i >= 0; i--)
        {
            MapBuffer1[i] = iCustom(NULL,0,IndicatorFileName,"Calculate",t3Original,b,MA_Period_1,0,i);
            MapBuffer2[i] = iCustom(NULL,0,IndicatorFileName,"Calculate",t3Original,b,MA_Period_2,0,i);
            MapBuffer3[i] = iCustom(NULL,0,IndicatorFileName,"Calculate",t3Original,b,MA_Period_3,0,i);
            MapBuffer4[i] = iCustom(NULL,0,IndicatorFileName,"Calculate",t3Original,b,MA_Period_4,0,i);
            MapBuffer5[i] = iCustom(NULL,0,IndicatorFileName,"Calculate",t3Original,b,MA_Period_5,0,i);
      }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int    t3.period;
double e1,e2,e3,e4,e5,e6;
double c1,c2,c3,c4;
double n,w1,w2,b2,b3;

//
//
//
//
//

double CalculateT3(int limit,int period)
{
   if (t3.period != period)
   {
      t3.period = period;
         b2 = b*b;
         b3 = b2*b;

         c1 = -b3;
         c2 = (3*(b2+b3));
         c3 = -3*(2*b2+b+b3);
         c4 = (1+3*b+b3+3*b2);

         n=period; if (n<1) n=1;

         if (!t3Original)
            n  = 1 + 0.5*(n-1);
         w1 = 2 / (n + 1);
         w2 = 1 - w1;
   }
   
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      e1 = w1*Close[i] + w2*ae1[i+1];
      e2 = w1*e1       + w2*ae2[i+1];
      e3 = w1*e2       + w2*ae3[i+1];
      e4 = w1*e3       + w2*ae4[i+1];
      e5 = w1*e4       + w2*ae5[i+1];
      e6 = w1*e5       + w2*ae6[i+1];
         t3Array[i]=c1*e6 + c2*e5 + c3*e4 + c4*e3;
         ae1[i] = e1;
         ae2[i] = e2;
         ae3[i] = e3;
         ae4[i] = e4;
         ae5[i] = e5;
         ae6[i] = e6;
   }   
}